#include <FK/FK.h>
#include "GuideObject.h"
#include "TrackBall.h"
#include "FrameController.h"
#include "OBB.h"

int main(int argc, char *argv[])
{
	Fl_Window		mainWindow(512, 512, "FK TEST");
	fk_Model		camera, lightModel;
	fk_Light		light;
	fk_Sphere		sph(4, 10.0);
	fk_Model		sphModel;
	fk_Scene		scene;
	fk_Window		window(0, 0, 512, 512);

	fk_TrackBall			tb(&window, &camera);
	fkut_GuideObject		guide;
	fkut_FrameController	fps;

	fk_Block		block(25.0, 35.0, 20.0), block2(50.0, 20.0, 20.0);
	fk_Model		blockModel, blockModel2;
	fkut_OBB		obb1, obb2;
	fk_Prism		prism, prism2;
	fk_Model		prismModel, prismModel2;
	fkut_Capsule	cap1, cap2;

	mainWindow.end();
	fk_InitMaterial();

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// ̂̐ݒ
	blockModel.setShape(&block);
	blockModel.setMaterial(Yellow);
	obb1.setBlockSize(25.0, 35.0, 20.0);
	obb1.setModel(&blockModel);

	blockModel2.setShape(&block2);
	blockModel2.setMaterial(Yellow);
	obb2.setBlockSize(50.0, 20.0, 20.0);
	obb2.setModel(&blockModel2);

	sphModel.setShape(&sph);
	sphModel.setMaterial(Cyan);

	prism.setTopRadius(10.0);
	prism.setBottomRadius(10.0);
	prism.setHeight(50.0);
	prism.setDivide(32);
	prismModel.setShape(&prism);
	prismModel.glMoveTo(-50.0, 0.0, -50.0);
	prismModel.glVec(1.0, 1.0, 0.0);
	cap1.setCapsuleSize(10.0, 50.0);
	cap1.setModel(&prismModel);

	prism2.setTopRadius(5.0);
	prism2.setBottomRadius(5.0);
	prism2.setHeight(30.0);
	prism2.setDivide(32);
	prismModel2.setShape(&prism2);
	prismModel2.glMoveTo(50.0, 0.0, 50.0);
	prismModel2.glVec(0.0, 1.0, 0.0);
	cap2.setCapsuleSize(5.0, 30.0);
	cap2.setModel(&prismModel2);

	// effBXvCXgɓo^
	scene.entryCamera(&camera);
	scene.entryModel(&lightModel);
	scene.entryModel(&blockModel);
	scene.entryModel(&blockModel2);
	scene.entryModel(&prismModel);
	scene.entryModel(&prismModel2);
	scene.entryModel(&sphModel);

	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 0.0, 200.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	mainWindow.show();
	window.show();

	guide.entryScene(&scene);

	fk_Vector	refV;

	while(true) {

		fps.TimeRegular();

		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		if(fps.GetDrawFlag()) window.drawWindow();
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		tb.update();

		// ̂ Y Sɉ]
		// blockModel.glRotateWithVec(0.0, 0.0, 0.0, fk_Y, FK_PI/100.0);

		if(window.getSpecialKeyStatus(FK_TAB, false)) {
			if(window.getKeyStatus('x', false)) {
				if(window.getSpecialKeyStatus(FK_RIGHT)) {
					prismModel2.loRotateWithVec(0.0, 0.0, 0.0, fk_X, 0.1);
				}
				if(window.getSpecialKeyStatus(FK_LEFT)) {
					prismModel2.loRotateWithVec(0.0, 0.0, 0.0, fk_X, -0.1);
				}
			} else if(window.getKeyStatus('y', false)) {
				if(window.getSpecialKeyStatus(FK_RIGHT)) {
					prismModel2.loRotateWithVec(0.0, 0.0, 0.0, fk_Y, 0.1);
				}
				if(window.getSpecialKeyStatus(FK_LEFT)) {
					prismModel2.loRotateWithVec(0.0, 0.0, 0.0, fk_Y, -0.1);
				}
			} else if(window.getKeyStatus('z', false)) {
				if(window.getSpecialKeyStatus(FK_RIGHT)) {
					prismModel2.loRotateWithVec(0.0, 0.0, 0.0, fk_Z, 0.1);
				}
				if(window.getSpecialKeyStatus(FK_LEFT)) {
					prismModel2.loRotateWithVec(0.0, 0.0, 0.0, fk_Z, -0.1);
				}
			} else {
				if(window.getSpecialKeyStatus(FK_RIGHT)) {
					prismModel2.glTranslate(1.0, 0.0, 0.0);
				}
				if(window.getSpecialKeyStatus(FK_LEFT)) {
					prismModel2.glTranslate(-1.0, 0.0, 0.0);
				}
			}
			if(window.getSpecialKeyStatus(FK_SHIFT_L)) {
				if(window.getSpecialKeyStatus(FK_UP)) {
					prismModel2.glTranslate(0.0, 1.0, 0.0);
				}
				if(window.getSpecialKeyStatus(FK_DOWN)) {
					prismModel2.glTranslate(0.0, -1.0, 0.0);
				}
			} else {
				if(window.getSpecialKeyStatus(FK_UP)) {
					prismModel2.glTranslate(0.0, 0.0, -1.0);
				}
				if(window.getSpecialKeyStatus(FK_DOWN)) {
					prismModel2.glTranslate(0.0, 0.0, 1.0);
				}
			}

			if(cap2.checkVSCapsule(cap1, &refV)) {
				prismModel2.glTranslate(refV);
			}

		} else if(window.getSpecialKeyStatus(FK_CTRL_L, false)) {
			scene.removeModel(&blockModel2);
			scene.entryModel(&sphModel);

			if(window.getKeyStatus('x', false)) {
				if(window.getSpecialKeyStatus(FK_RIGHT)) {
					blockModel.loRotateWithVec(0.0, 0.0, 0.0, fk_X, 0.1);
				}
				if(window.getSpecialKeyStatus(FK_LEFT)) {
					blockModel.loRotateWithVec(0.0, 0.0, 0.0, fk_X, -0.1);
				}
			} else if(window.getKeyStatus('y', false)) {
				if(window.getSpecialKeyStatus(FK_RIGHT)) {
					blockModel.loRotateWithVec(0.0, 0.0, 0.0, fk_Y, 0.1);
				}
				if(window.getSpecialKeyStatus(FK_LEFT)) {
					blockModel.loRotateWithVec(0.0, 0.0, 0.0, fk_Y, -0.1);
				}
			} else if(window.getKeyStatus('z', false)) {
				if(window.getSpecialKeyStatus(FK_RIGHT)) {
					blockModel.loRotateWithVec(0.0, 0.0, 0.0, fk_Z, 0.1);
				}
				if(window.getSpecialKeyStatus(FK_LEFT)) {
					blockModel.loRotateWithVec(0.0, 0.0, 0.0, fk_Z, -0.1);
				}
			} else {
				if(window.getSpecialKeyStatus(FK_RIGHT)) {
					sphModel.glTranslate(1.0, 0.0, 0.0);
				}
				if(window.getSpecialKeyStatus(FK_LEFT)) {
					sphModel.glTranslate(-1.0, 0.0, 0.0);
				}
			}
			if(window.getSpecialKeyStatus(FK_SHIFT_L)) {
				if(window.getSpecialKeyStatus(FK_UP)) {
					sphModel.glTranslate(0.0, 1.0, 0.0);
				}
				if(window.getSpecialKeyStatus(FK_DOWN)) {
					sphModel.glTranslate(0.0, -1.0, 0.0);
				}
			} else {
				if(window.getSpecialKeyStatus(FK_UP)) {
					sphModel.glTranslate(0.0, 0.0, -1.0);
				}
				if(window.getSpecialKeyStatus(FK_DOWN)) {
					sphModel.glTranslate(0.0, 0.0, 1.0);
				}
			}

			if(obb1.checkVSSphere(sphModel.getPosition(), 10.0, refV)) {
				sphModel.glTranslate(-refV);
				blockModel.setMaterial(Red);
			} else {
				blockModel.setMaterial(Yellow);
			}
		} else {
			scene.removeModel(&sphModel);
			scene.entryModel(&blockModel2);

			if(window.getKeyStatus('x', false)) {
				if(window.getSpecialKeyStatus(FK_RIGHT)) {
					blockModel2.loRotateWithVec(0.0, 0.0, 0.0, fk_X, 0.1);
				}
				if(window.getSpecialKeyStatus(FK_LEFT)) {
					blockModel2.loRotateWithVec(0.0, 0.0, 0.0, fk_X, -0.1);
				}
			} else if(window.getKeyStatus('y', false)) {
				if(window.getSpecialKeyStatus(FK_RIGHT)) {
					blockModel2.loRotateWithVec(0.0, 0.0, 0.0, fk_Y, 0.1);
				}
				if(window.getSpecialKeyStatus(FK_LEFT)) {
					blockModel2.loRotateWithVec(0.0, 0.0, 0.0, fk_Y, -0.1);
				}
			} else if(window.getKeyStatus('z', false)) {
				if(window.getSpecialKeyStatus(FK_RIGHT)) {
					blockModel2.loRotateWithVec(0.0, 0.0, 0.0, fk_Z, 0.1);
				}
				if(window.getSpecialKeyStatus(FK_LEFT)) {
					blockModel2.loRotateWithVec(0.0, 0.0, 0.0, fk_Z, -0.1);
				}
			} else {
				if(window.getSpecialKeyStatus(FK_RIGHT)) {
					blockModel2.glTranslate(1.0, 0.0, 0.0);
				}
				if(window.getSpecialKeyStatus(FK_LEFT)) {
					blockModel2.glTranslate(-1.0, 0.0, 0.0);
				}
			}
			if(window.getSpecialKeyStatus(FK_SHIFT_L)) {
				if(window.getSpecialKeyStatus(FK_UP)) {
					blockModel2.glTranslate(0.0, 1.0, 0.0);
				}
				if(window.getSpecialKeyStatus(FK_DOWN)) {
					blockModel2.glTranslate(0.0, -1.0, 0.0);
				}
			} else {
				if(window.getSpecialKeyStatus(FK_UP)) {
					blockModel2.glTranslate(0.0, 0.0, -1.0);
				}
				if(window.getSpecialKeyStatus(FK_DOWN)) {
					blockModel2.glTranslate(0.0, 0.0, 1.0);
				}
			}

			if(obb2.checkVSOBB(obb1, refV)) {
				blockModel2.glTranslate(refV);
				blockModel2.setMaterial(Red);
			} else {
				blockModel2.setMaterial(Yellow);
			}
		}
	}

	return 0;
}
